diff --git a/gcc/cp/error.c b/gcc/cp/error.c
index 454feb5..86f54b4 100644
--- a/gcc/cp/error.c
+++ b/gcc/cp/error.c
@@ -180,7 +180,7 @@ get_non_default_template_args_count (tree args, int flags)
 	 turn cause codegen differences between compilations with and
 	 without -g.  */
       (flags & TFF_NO_OMIT_DEFAULT_TEMPLATE_ARGUMENTS) != 0
-      || !flag_pretty_templates)
+      || !GCC_OPTION (flag_pretty_templates))
     return n;
 
   return GET_NON_DEFAULT_TEMPLATE_ARGS_COUNT (INNERMOST_TEMPLATE_ARGS (args));
@@ -370,7 +370,7 @@ dump_type (cxx_pretty_printer *pp, tree t, int flags)
       tree decl = TYPE_NAME (t);
       if ((flags & TFF_CHASE_TYPEDEF)
 	       || DECL_SELF_REFERENCE_P (decl)
-	       || (!flag_pretty_templates
+	       || (!GCC_OPTION (flag_pretty_templates)
 		   && DECL_LANG_SPECIFIC (decl) && DECL_TEMPLATE_INFO (decl)))
 	t = strip_typedefs (t);
       else if (alias_template_specialization_p (t))
@@ -625,7 +625,7 @@ dump_aggr_type (cxx_pretty_printer *pp, tree t, int flags)
 
       if ((typdef
 	   && ((flags & TFF_CHASE_TYPEDEF)
-	       || (!flag_pretty_templates && DECL_LANG_SPECIFIC (name)
+	       || (!GCC_OPTION (flag_pretty_templates) && DECL_LANG_SPECIFIC (name)
 		   && DECL_TEMPLATE_INFO (name))))
 	  || DECL_SELF_REFERENCE_P (name))
 	{
@@ -1433,7 +1433,7 @@ dump_function_decl (cxx_pretty_printer *pp, tree t, int flags)
 
   /* Pretty print template instantiations only.  */
   if (DECL_USE_TEMPLATE (t) && DECL_TEMPLATE_INFO (t)
-      && flag_pretty_templates)
+      && GCC_OPTION (flag_pretty_templates))
     {
       tree tmpl;
 
@@ -2012,7 +2012,7 @@ dump_expr (cxx_pretty_printer *pp, tree t, int flags)
 	      }
 	    skipfirst = true;
 	  }
-	if (flag_sanitize & SANITIZE_UNDEFINED
+	if (GCC_OPTION (flag_sanitize) & SANITIZE_UNDEFINED
 	    && is_ubsan_builtin_p (fn))
 	  {
 	    pp_string (cxx_pp, M_("<ubsan routine call>"));
@@ -3269,17 +3269,17 @@ print_instantiation_partial_context (diagnostic_context *context,
 
   t = t0;
 
-  if (template_backtrace_limit
-      && n_total > template_backtrace_limit) 
+  if (GCC_OPTION (template_backtrace_limit)
+      && n_total > GCC_OPTION (template_backtrace_limit)) 
     {
-      int skip = n_total - template_backtrace_limit;
-      int head = template_backtrace_limit / 2;
+      int skip = n_total - GCC_OPTION (template_backtrace_limit);
+      int head = GCC_OPTION (template_backtrace_limit) / 2;
 
       /* Avoid skipping just 1.  If so, skip 2.  */
       if (skip == 1)
        {
          skip = 2;
-         head = (template_backtrace_limit - 1) / 2;
+         head = (GCC_OPTION (template_backtrace_limit) - 1) / 2;
        }
      
       for (n = 0; n < head; n++)
diff --git a/gcc/cp/except.c b/gcc/cp/except.c
index 221971a..2c9770c 100644
--- a/gcc/cp/except.c
+++ b/gcc/cp/except.c
@@ -196,7 +196,7 @@ do_begin_catch (void)
       fn = declare_library_fn (fn, ptr_type_node, ptr_type_node, ECF_NOTHROW);
 
       /* Create its transactional-memory equivalent.  */
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	{
 	  tree fn2 = get_identifier ("_ITM_cxa_begin_catch");
 	  if (!get_global_value_if_present (fn2, &fn2))
@@ -244,7 +244,7 @@ do_end_catch (tree type)
       fn = push_void_library_fn (fn, void_list_node, 0);
 
       /* Create its transactional-memory equivalent.  */
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	{
 	  tree fn2 = get_identifier ("_ITM_cxa_end_catch");
 	  if (!get_global_value_if_present (fn2, &fn2))
@@ -376,7 +376,7 @@ build_must_not_throw_expr (tree body, tree cond)
 {
   tree type = body ? TREE_TYPE (body) : void_type_node;
 
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return body;
 
   if (cond && !value_dependent_expression_p (cond))
@@ -459,7 +459,7 @@ initialize_handler_parm (tree decl, tree exp)
 static inline int
 doing_eh (void)
 {
-  if (! flag_exceptions)
+  if (! GCC_OPTION (flag_exceptions))
     {
       static int warned = 0;
       if (! warned)
@@ -523,7 +523,7 @@ expand_start_catch_block (tree decl)
   /* If the C++ object needs constructing, we need to do that before
      calling __cxa_begin_catch, so that std::uncaught_exception gets
      the right value during the copy constructor.  */
-  else if (flag_use_cxa_get_exception_ptr
+  else if (GCC_OPTION (flag_use_cxa_get_exception_ptr)
 	   && TYPE_NEEDS_CONSTRUCTING (TREE_TYPE (decl)))
     {
       exp = do_get_exception_ptr ();
@@ -633,7 +633,7 @@ do_allocate_exception (tree type)
       fn = declare_library_fn (fn, ptr_type_node, size_type_node,
 			        ECF_NOTHROW | ECF_MALLOC);
 
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	{
 	  tree fn2 = get_identifier ("_ITM_cxa_allocate_exception");
 	  if (!get_global_value_if_present (fn2, &fn2))
@@ -775,7 +775,7 @@ build_throw (tree exp)
 					  cleanup_type, NULL_TREE);
 	  fn = push_throw_library_fn (fn, tmp);
 
-	  if (flag_tm)
+	  if (GCC_OPTION (flag_tm))
 	    {
 	      tree fn2 = get_identifier ("_ITM_cxa_throw");
 	      if (!get_global_value_if_present (fn2, &fn2))
@@ -906,7 +906,7 @@ build_throw (tree exp)
 	    (fn, build_function_type_list (void_type_node, NULL_TREE));
 	}
 
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	apply_tm_attr (fn, get_identifier ("transaction_pure"));
 
       /* ??? Indicate that this function call allows exceptions of the type
@@ -1245,7 +1245,7 @@ expr_noexcept_p (tree expr, tsubst_flags_t complain)
   fn = cp_walk_tree_without_duplicates (&expr, check_noexcept_r, 0);
   if (fn)
     {
-      if ((complain & tf_warning) && warn_noexcept
+      if ((complain & tf_warning) && GCC_OPTION (warn_noexcept)
 	  && TREE_CODE (fn) == FUNCTION_DECL)
 	{
 	  if (!DECL_INITIAL (fn))
@@ -1290,7 +1290,7 @@ type_noexcept_p (const_tree type)
 {
   tree spec = TYPE_RAISES_EXCEPTIONS (type);
   gcc_assert (!DEFERRED_NOEXCEPT_SPEC_P (spec));
-  if (flag_nothrow_opt)
+  if (GCC_OPTION (flag_nothrow_opt))
     return nothrow_spec_p (spec);
   else
     return spec == noexcept_true_spec;
diff --git a/gcc/cp/friend.c b/gcc/cp/friend.c
index 150b392..383e387 100644
--- a/gcc/cp/friend.c
+++ b/gcc/cp/friend.c
@@ -536,7 +536,7 @@ do_friend (tree ctype, tree declarator, tree decl,
 	  /* We must check whether the decl refers to template
 	     arguments before push_template_decl_real adds a
 	     reference to the containing template class.  */
-	  int warn = (warn_nontemplate_friend
+	  int warn = (GCC_OPTION (warn_nontemplate_friend)
 		      && ! funcdef_flag && ! is_friend_template
 		      && current_template_parms
 		      && uses_template_parms (decl));
diff --git a/gcc/cp/init.c b/gcc/cp/init.c
index 7f5d045..302de3e 100644
--- a/gcc/cp/init.c
+++ b/gcc/cp/init.c
@@ -562,7 +562,7 @@ perform_member_init (tree member, tree init)
 
   /* Effective C++ rule 12 requires that all data members be
      initialized.  */
-  if (warn_ecpp && init == NULL_TREE && TREE_CODE (type) != ARRAY_TYPE)
+  if (GCC_OPTION (warn_ecpp) && init == NULL_TREE && TREE_CODE (type) != ARRAY_TYPE)
     warning_at (DECL_SOURCE_LOCATION (current_function_decl), OPT_Weffc__,
 		"%qD should be initialized in the member initialization list",
 		member);
@@ -575,7 +575,7 @@ perform_member_init (tree member, tree init)
   if (decl == error_mark_node)
     return;
 
-  if (warn_init_self && init && TREE_CODE (init) == TREE_LIST
+  if (GCC_OPTION (warn_init_self) && init && TREE_CODE (init) == TREE_LIST
       && TREE_CHAIN (init) == NULL_TREE)
     {
       tree val = TREE_VALUE (init);
@@ -866,7 +866,7 @@ sort_mem_initializers (tree t, tree mem_inits)
       /* Issue a warning if the explicit initializer order does not
 	 match that which will actually occur.
 	 ??? Are all these on the correct lines?  */
-      if (warn_reorder && !subobject_init)
+      if (GCC_OPTION (warn_reorder) && !subobject_init)
 	{
 	  if (TREE_CODE (TREE_PURPOSE (next_subobject)) == FIELD_DECL)
 	    warning (OPT_Wreorder, "%q+D will be initialized after",
@@ -1061,7 +1061,7 @@ emit_mem_initializers (tree mem_inits)
 	     the base class should probably be explicitly initialized if there
 	     is a user-defined constructor in the base class (other than the
 	     default constructor, which will be called anyway).  */
-	  if (extra_warnings
+	  if (GCC_OPTION (extra_warnings)
 	      && DECL_COPY_CONSTRUCTOR_P (current_function_decl)
 	      && type_has_user_nondefault_constructor (BINFO_TYPE (subobject)))
 	    warning_at (DECL_SOURCE_LOCATION (current_function_decl),
@@ -1941,7 +1941,7 @@ build_offset_ref (tree type, tree member, bool address_p,
 	  member = build2 (OFFSET_REF, TREE_TYPE (member), decl, member);
 	  /* In Microsoft mode, treat a non-static member function as if
 	     it were a pointer-to-member.  */
-	  if (flag_ms_extensions)
+	  if (GCC_OPTION (flag_ms_extensions))
 	    {
 	      PTRMEM_OK_P (member) = 1;
 	      return cp_build_addr_expr (member, complain);
@@ -2549,7 +2549,7 @@ build_new_1 (vec<tree, va_gc> **placement, tree type, tree nelts,
 	    }
 	  /* Perform the overflow check.  */
 	  tree errval = TYPE_MAX_VALUE (sizetype);
-	  if (cxx_dialect >= cxx11 && flag_exceptions)
+	  if (cxx_dialect >= cxx11 && GCC_OPTION (flag_exceptions))
 	    errval = throw_bad_array_new_length ();
 	  if (outer_nelts_check != NULL_TREE)
             size = fold_build3 (COND_EXPR, sizetype, outer_nelts_check,
@@ -2675,7 +2675,7 @@ build_new_1 (vec<tree, va_gc> **placement, tree type, tree nelts,
      So check for a null exception spec on the op new we just called.  */
 
   nothrow = TYPE_NOTHROW_P (TREE_TYPE (alloc_fn));
-  check_new = (flag_check_new || nothrow) && ! use_java_new;
+  check_new = (GCC_OPTION (flag_check_new) || nothrow) && ! use_java_new;
 
   if (cookie_size)
     {
@@ -2855,7 +2855,7 @@ build_new_1 (vec<tree, va_gc> **placement, tree type, tree nelts,
 	 unambiguous matching deallocation function can be found,
 	 propagating the exception does not cause the object's memory to be
 	 freed.  */
-      if (flag_exceptions && ! use_java_new)
+      if (GCC_OPTION (flag_exceptions) && ! use_java_new)
 	{
 	  enum tree_code dcode = array_p ? VEC_DELETE_EXPR : DELETE_EXPR;
 	  tree cleanup;
@@ -3420,7 +3420,7 @@ build_vec_init (tree base, tree maxindex, tree init,
   if (init && TREE_CODE (init) == CONSTRUCTOR
       && CONSTRUCTOR_NELTS (init) > 0
       && !TREE_CONSTANT (maxindex)
-      && flag_exceptions)
+      && GCC_OPTION (flag_exceptions))
     length_check = fold_build2 (LT_EXPR, boolean_type_node, maxindex,
 				size_int (CONSTRUCTOR_NELTS (init) - 1));
 
@@ -3519,7 +3519,7 @@ build_vec_init (tree base, tree maxindex, tree init,
   /* Protect the entire array initialization so that we can destroy
      the partially constructed array if an exception is thrown.
      But don't do this if we're assigning.  */
-  if (flag_exceptions && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (type)
+  if (GCC_OPTION (flag_exceptions) && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (type)
       && from_array != 2)
     {
       try_block = begin_try_block ();
@@ -3781,7 +3781,7 @@ build_vec_init (tree base, tree maxindex, tree init,
     }
 
   /* Make sure to cleanup any partially constructed elements.  */
-  if (flag_exceptions && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (type)
+  if (GCC_OPTION (flag_exceptions) && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (type)
       && from_array != 2)
     {
       tree e;
@@ -3937,7 +3937,7 @@ build_delete (tree otype, tree addr, special_function_kind auto_delete,
 		}
 	      complete_p = false;
 	    }
-	  else if (auto_delete == sfk_deleting_destructor && warn_delnonvdtor
+	  else if (auto_delete == sfk_deleting_destructor && GCC_OPTION (warn_delnonvdtor)
 	           && MAYBE_CLASS_TYPE_P (type) && !CLASSTYPE_FINAL (type)
 		   && TYPE_POLYMORPHIC_P (type))
 	    {
diff --git a/gcc/cp/lex.c b/gcc/cp/lex.c
index 3fe275e..c7dfe40 100644
--- a/gcc/cp/lex.c
+++ b/gcc/cp/lex.c
@@ -174,9 +174,9 @@ init_reswords (void)
 
   if (cxx_dialect < cxx11)
     mask |= D_CXX0X;
-  if (flag_no_asm)
+  if (GCC_OPTION (flag_no_asm))
     mask |= D_ASM | D_EXT;
-  if (flag_no_gnu_keywords)
+  if (GCC_OPTION (flag_no_gnu_keywords))
     mask |= D_EXT;
 
   /* The Objective-C keywords are all context-dependent.  */
@@ -362,8 +362,8 @@ handle_pragma_interface (cpp_reader* /*dfile*/)
     {
       /* If this is zero at this point, then we are
 	 auto-implementing.  */
-      if (main_input_filename == 0)
-	main_input_filename = LOCATION_FILE (input_location);
+      if (GCC_OPTION (main_input_filename) == 0)
+	GCC_OPTION (main_input_filename) = LOCATION_FILE (input_location);
     }
 
   finfo->interface_only = interface_strcmp (filename);
@@ -394,8 +394,8 @@ handle_pragma_implementation (cpp_reader* /*dfile*/)
 
   if (fname == 0)
     {
-      if (main_input_filename)
-	filename = main_input_filename;
+      if (GCC_OPTION (main_input_filename))
+	filename = GCC_OPTION (main_input_filename);
       else
 	filename = LOCATION_FILE (input_location);
       filename = lbasename (filename);
@@ -493,7 +493,7 @@ unqualified_fn_lookup_error (tree name)
 		 "parameter, so a declaration of %qD must be available",
 		 name, name);
 
-      if (!flag_permissive)
+      if (!GCC_OPTION (flag_permissive))
 	{
 	  static bool hint;
 	  if (!hint)
@@ -709,8 +709,8 @@ in_main_input_context (void)
   struct tinst_level *tl = outermost_tinst_level();
 
   if (tl)
-    return filename_cmp (main_input_filename,
+    return filename_cmp (GCC_OPTION (main_input_filename),
 			 LOCATION_FILE (tl->locus)) == 0;
   else
-    return filename_cmp (main_input_filename, LOCATION_FILE (input_location)) == 0;
+    return filename_cmp (GCC_OPTION (main_input_filename), LOCATION_FILE (input_location)) == 0;
 }
diff --git a/gcc/cp/mangle.c b/gcc/cp/mangle.c
index 251edb1..5e3ce82 100644
--- a/gcc/cp/mangle.c
+++ b/gcc/cp/mangle.c
@@ -3352,7 +3352,7 @@ start_mangling (const tree entity)
 static void
 finish_mangling_internal (const bool warn)
 {
-  if (warn_abi && warn && G.need_abi_warning)
+  if (GCC_OPTION (warn_abi) && warn && G.need_abi_warning)
     warning (OPT_Wabi, "the mangled name of %qD will change in a future "
 	     "version of GCC",
 	     G.entity);
@@ -3502,11 +3502,11 @@ mangle_decl (const tree decl)
 		"avoids this error with a change in mangling");
 
 #ifdef ASM_OUTPUT_DEF
-      save_ver = flag_abi_version;
-      flag_abi_version = 0;
+      save_ver = GCC_OPTION (flag_abi_version);
+      GCC_OPTION (flag_abi_version) = 0;
       id2 = mangle_decl_string (decl);
       id2 = targetm.mangle_decl_assembler_name (decl, id2);
-      flag_abi_version = save_ver;
+      GCC_OPTION (flag_abi_version) = save_ver;
 
       alias = make_alias_for (decl, id2);
       DECL_IGNORED_P (alias) = 1;
diff --git a/gcc/cp/method.c b/gcc/cp/method.c
index d72b564..92e177a 100644
--- a/gcc/cp/method.c
+++ b/gcc/cp/method.c
@@ -257,7 +257,7 @@ make_alias_for_thunk (tree function)
 
   alias = make_alias_for (function, get_identifier (buf));
 
-  if (!flag_syntax_only)
+  if (!GCC_OPTION (flag_syntax_only))
     {
       struct cgraph_node *funcn, *aliasn;
       funcn = cgraph_get_node (function);
@@ -345,7 +345,7 @@ use_thunk (tree thunk_fndecl, bool emit_p)
   DECL_COMDAT (thunk_fndecl) = DECL_COMDAT (function);
   DECL_WEAK (thunk_fndecl) = DECL_WEAK (function);
 
-  if (flag_syntax_only)
+  if (GCC_OPTION (flag_syntax_only))
     {
       TREE_ASM_WRITTEN (thunk_fndecl) = 1;
       return;
@@ -356,11 +356,11 @@ use_thunk (tree thunk_fndecl, bool emit_p)
   if (TARGET_USE_LOCAL_THUNK_ALIAS_P (function)
       && targetm_common.have_named_sections)
     {
-      resolve_unique_section (function, 0, flag_function_sections);
+      resolve_unique_section (function, 0, GCC_OPTION (flag_function_sections));
 
       if (DECL_SECTION_NAME (function) != NULL && DECL_ONE_ONLY (function))
 	{
-	  resolve_unique_section (thunk_fndecl, 0, flag_function_sections);
+	  resolve_unique_section (thunk_fndecl, 0, GCC_OPTION (flag_function_sections));
 
 	  /* Output the thunk into the same section as function.  */
 	  DECL_SECTION_NAME (thunk_fndecl) = DECL_SECTION_NAME (function);
@@ -1999,7 +1999,7 @@ lazily_declare_fn (special_function_kind sfk, tree type)
       /* G++ 3.2 put the implicit destructor at the *beginning* of the
 	 TYPE_METHODS list, which cause the destructor to be emitted
 	 in an incorrect location in the vtable.  */
-      if (warn_abi && sfk == sfk_destructor && DECL_VIRTUAL_P (fn))
+      if (GCC_OPTION (warn_abi) && sfk == sfk_destructor && DECL_VIRTUAL_P (fn))
 	warning (OPT_Wabi, "vtable layout for class %qT may not be ABI-compliant"
 		 "and may change in a future version of GCC due to "
 		 "implicit virtual destructor",
diff --git a/gcc/cp/name-lookup.c b/gcc/cp/name-lookup.c
index ea16061..fc23cab 100644
--- a/gcc/cp/name-lookup.c
+++ b/gcc/cp/name-lookup.c
@@ -986,7 +986,7 @@ pushdecl_maybe_friend_1 (tree x, bool is_friend)
 
       if (TREE_CODE (x) == FUNCTION_DECL
 	  && is_friend
-	  && !flag_friend_injection)
+	  && !GCC_OPTION (flag_friend_injection))
 	{
 	  /* This is a new declaration of a friend function, so hide
 	     it from ordinary function lookup.  */
@@ -1195,7 +1195,7 @@ pushdecl_maybe_friend_1 (tree x, bool is_friend)
 		  nowarn = true;
 		}
 
-	      if (warn_shadow && !nowarn)
+	      if (GCC_OPTION (warn_shadow) && !nowarn)
 		{
 		  bool warned;
 
@@ -1218,7 +1218,7 @@ pushdecl_maybe_friend_1 (tree x, bool is_friend)
 	    }
 
 	  /* Maybe warn if shadowing something else.  */
-	  else if (warn_shadow && !DECL_EXTERNAL (x)
+	  else if (GCC_OPTION (warn_shadow) && !DECL_EXTERNAL (x)
                    /* No shadow warnings for internally generated vars unless
                       it's an implicit typedef (see create_implicit_typedef
                       in decl.c).  */
@@ -1421,7 +1421,7 @@ check_for_out_of_scope_variable (tree decl)
     {
       permerror (input_location, "name lookup of %qD changed for ISO %<for%> scoping",
 	         DECL_NAME (decl));
-      if (flag_permissive)
+      if (GCC_OPTION (flag_permissive))
         permerror (input_location, "  using obsolete binding at %q+D", decl);
       else
 	{
@@ -2351,7 +2351,7 @@ push_overloaded_decl_1 (tree decl, int flags, bool is_friend)
       if (TREE_CODE (old) == TYPE_DECL && DECL_ARTIFICIAL (old))
 	{
 	  tree t = TREE_TYPE (old);
-	  if (MAYBE_CLASS_TYPE_P (t) && warn_shadow
+	  if (MAYBE_CLASS_TYPE_P (t) && GCC_OPTION (warn_shadow)
 	      && (! DECL_IN_SYSTEM_HEADER (decl)
 		  || ! DECL_IN_SYSTEM_HEADER (old)))
 	    warning (OPT_Wshadow, "%q#D hides constructor for %q#T", decl, t);
diff --git a/gcc/cp/optimize.c b/gcc/cp/optimize.c
index b089432..ffde94c 100644
--- a/gcc/cp/optimize.c
+++ b/gcc/cp/optimize.c
@@ -260,7 +260,7 @@ maybe_thunk_body (tree fn, bool force)
   int parmno, vtt_parmno, max_parms;
   tree fns[3];
 
-  if (!force && !flag_declone_ctor_dtor)
+  if (!force && !GCC_OPTION (flag_declone_ctor_dtor))
     return 0;
 
   /* If function accepts variable arguments, give up.  */
